require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ARMREG_H_)) {
    eval 'sub _MACHINE_ARMREG_H_ () {1;}' unless defined(&_MACHINE_ARMREG_H_);
    eval 'sub INSN_SIZE () {4;}' unless defined(&INSN_SIZE);
    eval 'sub READ_SPECIALREG {
        my($reg) = @_;
	    eval q(({  &uint64_t  &val;  &__asm  &__volatile(\\"mrs	%0, \\"  &__STRING($reg) : \\"=&r\\" ( &val));  &val; }));
    }' unless defined(&READ_SPECIALREG);
    eval 'sub WRITE_SPECIALREG {
        my($reg, $val) = @_;
	    eval q( &__asm  &__volatile(\\"msr	\\"  &__STRING($reg) \\", %0\\" : : \\"r\\"(( &uint64_t)$val)));
    }' unless defined(&WRITE_SPECIALREG);
    eval 'sub CNTHCTL_EVNTI_MASK () {(0xf << 4);}' unless defined(&CNTHCTL_EVNTI_MASK);
    eval 'sub CNTHCTL_EVNTDIR () {(1<< 3);}' unless defined(&CNTHCTL_EVNTDIR);
    eval 'sub CNTHCTL_EVNTEN () {(1<< 2);}' unless defined(&CNTHCTL_EVNTEN);
    eval 'sub CNTHCTL_EL1PCEN () {(1<< 1);}' unless defined(&CNTHCTL_EL1PCEN);
    eval 'sub CNTHCTL_EL1PCTEN () {(1<< 0);}' unless defined(&CNTHCTL_EL1PCTEN);
    eval 'sub CPACR_FPEN_MASK () {(0x3 << 20);}' unless defined(&CPACR_FPEN_MASK);
    eval 'sub CPACR_FPEN_TRAP_ALL1 () {(0x << 20);}' unless defined(&CPACR_FPEN_TRAP_ALL1);
    eval 'sub CPACR_FPEN_TRAP_EL0 () {(0x1 << 20);}' unless defined(&CPACR_FPEN_TRAP_EL0);
    eval 'sub CPACR_FPEN_TRAP_ALL2 () {(0x2 << 20);}' unless defined(&CPACR_FPEN_TRAP_ALL2);
    eval 'sub CPACR_FPEN_TRAP_NONE () {(0x3 << 20);}' unless defined(&CPACR_FPEN_TRAP_NONE);
    eval 'sub CPACR_TTA () {(0x1 << 28);}' unless defined(&CPACR_TTA);
    eval 'sub CTR_DLINE_SHIFT () {16;}' unless defined(&CTR_DLINE_SHIFT);
    eval 'sub CTR_DLINE_MASK () {(0xf <<  &CTR_DLINE_SHIFT);}' unless defined(&CTR_DLINE_MASK);
    eval 'sub CTR_DLINE_SIZE {
        my($reg) = @_;
	    eval q(((($reg) &  &CTR_DLINE_MASK) >>  &CTR_DLINE_SHIFT));
    }' unless defined(&CTR_DLINE_SIZE);
    eval 'sub CTR_ILINE_SHIFT () {0;}' unless defined(&CTR_ILINE_SHIFT);
    eval 'sub CTR_ILINE_MASK () {(0xf <<  &CTR_ILINE_SHIFT);}' unless defined(&CTR_ILINE_MASK);
    eval 'sub CTR_ILINE_SIZE {
        my($reg) = @_;
	    eval q(((($reg) &  &CTR_ILINE_MASK) >>  &CTR_ILINE_SHIFT));
    }' unless defined(&CTR_ILINE_SIZE);
    eval 'sub DCZID_DZP () {(1<< 4);}' unless defined(&DCZID_DZP);
    eval 'sub DCZID_BS_SHIFT () {0;}' unless defined(&DCZID_BS_SHIFT);
    eval 'sub DCZID_BS_MASK () {(0xf <<  &DCZID_BS_SHIFT);}' unless defined(&DCZID_BS_MASK);
    eval 'sub DCZID_BS_SIZE {
        my($reg) = @_;
	    eval q(((($reg) &  &DCZID_BS_MASK) >>  &DCZID_BS_SHIFT));
    }' unless defined(&DCZID_BS_SIZE);
    eval 'sub ESR_ELx_ISS_MASK () {0xffffff;}' unless defined(&ESR_ELx_ISS_MASK);
    eval 'sub ISS_INSN_FnV () {(0x1 << 10);}' unless defined(&ISS_INSN_FnV);
    eval 'sub ISS_INSN_EA () {(0x1 << 9);}' unless defined(&ISS_INSN_EA);
    eval 'sub ISS_INSN_S1PTW () {(0x1 << 7);}' unless defined(&ISS_INSN_S1PTW);
    eval 'sub ISS_INSN_IFSC_MASK () {(0x1f << 0);}' unless defined(&ISS_INSN_IFSC_MASK);
    eval 'sub ISS_DATA_ISV () {(0x1 << 24);}' unless defined(&ISS_DATA_ISV);
    eval 'sub ISS_DATA_SAS_MASK () {(0x3 << 22);}' unless defined(&ISS_DATA_SAS_MASK);
    eval 'sub ISS_DATA_SSE () {(0x1 << 21);}' unless defined(&ISS_DATA_SSE);
    eval 'sub ISS_DATA_SRT_MASK () {(0x1f << 16);}' unless defined(&ISS_DATA_SRT_MASK);
    eval 'sub ISS_DATA_SF () {(0x1 << 15);}' unless defined(&ISS_DATA_SF);
    eval 'sub ISS_DATA_AR () {(0x1 << 14);}' unless defined(&ISS_DATA_AR);
    eval 'sub ISS_DATA_FnV () {(0x1 << 10);}' unless defined(&ISS_DATA_FnV);
    eval 'sub ISS_DATa_EA () {(0x1 << 9);}' unless defined(&ISS_DATa_EA);
    eval 'sub ISS_DATa_CM () {(0x1 << 8);}' unless defined(&ISS_DATa_CM);
    eval 'sub ISS_INSN_S1PTW () {(0x1 << 7);}' unless defined(&ISS_INSN_S1PTW);
    eval 'sub ISS_DATa_WnR () {(0x1 << 6);}' unless defined(&ISS_DATa_WnR);
    eval 'sub ISS_DATA_DFSC_MASK () {(0x1f << 0);}' unless defined(&ISS_DATA_DFSC_MASK);
    eval 'sub ISS_DATA_DFSC_ASF_L0 () {(0x << 0);}' unless defined(&ISS_DATA_DFSC_ASF_L0);
    eval 'sub ISS_DATA_DFSC_ASF_L1 () {(0x1 << 0);}' unless defined(&ISS_DATA_DFSC_ASF_L1);
    eval 'sub ISS_DATA_DFSC_ASF_L2 () {(0x2 << 0);}' unless defined(&ISS_DATA_DFSC_ASF_L2);
    eval 'sub ISS_DATA_DFSC_ASF_L3 () {(0x3 << 0);}' unless defined(&ISS_DATA_DFSC_ASF_L3);
    eval 'sub ISS_DATA_DFSC_TF_L0 () {(0x4 << 0);}' unless defined(&ISS_DATA_DFSC_TF_L0);
    eval 'sub ISS_DATA_DFSC_TF_L1 () {(0x5 << 0);}' unless defined(&ISS_DATA_DFSC_TF_L1);
    eval 'sub ISS_DATA_DFSC_TF_L2 () {(0x6 << 0);}' unless defined(&ISS_DATA_DFSC_TF_L2);
    eval 'sub ISS_DATA_DFSC_TF_L3 () {(0x7 << 0);}' unless defined(&ISS_DATA_DFSC_TF_L3);
    eval 'sub ISS_DATA_DFSC_AFF_L1 () {(0x9 << 0);}' unless defined(&ISS_DATA_DFSC_AFF_L1);
    eval 'sub ISS_DATA_DFSC_AFF_L2 () {(0xa << 0);}' unless defined(&ISS_DATA_DFSC_AFF_L2);
    eval 'sub ISS_DATA_DFSC_AFF_L3 () {(0xb << 0);}' unless defined(&ISS_DATA_DFSC_AFF_L3);
    eval 'sub ISS_DATA_DFSC_PF_L1 () {(0xd << 0);}' unless defined(&ISS_DATA_DFSC_PF_L1);
    eval 'sub ISS_DATA_DFSC_PF_L2 () {(0xe << 0);}' unless defined(&ISS_DATA_DFSC_PF_L2);
    eval 'sub ISS_DATA_DFSC_PF_L3 () {(0xf << 0);}' unless defined(&ISS_DATA_DFSC_PF_L3);
    eval 'sub ISS_DATA_DFSC_EXT () {(0x10 << 0);}' unless defined(&ISS_DATA_DFSC_EXT);
    eval 'sub ISS_DATA_DFSC_EXT_L0 () {(0x14 << 0);}' unless defined(&ISS_DATA_DFSC_EXT_L0);
    eval 'sub ISS_DATA_DFSC_EXT_L1 () {(0x15 << 0);}' unless defined(&ISS_DATA_DFSC_EXT_L1);
    eval 'sub ISS_DATA_DFSC_EXT_L2 () {(0x16 << 0);}' unless defined(&ISS_DATA_DFSC_EXT_L2);
    eval 'sub ISS_DATA_DFSC_EXT_L3 () {(0x17 << 0);}' unless defined(&ISS_DATA_DFSC_EXT_L3);
    eval 'sub ISS_DATA_DFSC_ECC () {(0x18 << 0);}' unless defined(&ISS_DATA_DFSC_ECC);
    eval 'sub ISS_DATA_DFSC_ECC_L0 () {(0x1c << 0);}' unless defined(&ISS_DATA_DFSC_ECC_L0);
    eval 'sub ISS_DATA_DFSC_ECC_L1 () {(0x1d << 0);}' unless defined(&ISS_DATA_DFSC_ECC_L1);
    eval 'sub ISS_DATA_DFSC_ECC_L2 () {(0x1e << 0);}' unless defined(&ISS_DATA_DFSC_ECC_L2);
    eval 'sub ISS_DATA_DFSC_ECC_L3 () {(0x1f << 0);}' unless defined(&ISS_DATA_DFSC_ECC_L3);
    eval 'sub ISS_DATA_DFSC_ALIGN () {(0x21 << 0);}' unless defined(&ISS_DATA_DFSC_ALIGN);
    eval 'sub ISS_DATA_DFSC_TLB_CONFLICT () {(0x28 << 0);}' unless defined(&ISS_DATA_DFSC_TLB_CONFLICT);
    eval 'sub ESR_ELx_IL () {(0x1 << 25);}' unless defined(&ESR_ELx_IL);
    eval 'sub ESR_ELx_EC_SHIFT () {26;}' unless defined(&ESR_ELx_EC_SHIFT);
    eval 'sub ESR_ELx_EC_MASK () {(0x3f << 26);}' unless defined(&ESR_ELx_EC_MASK);
    eval 'sub ESR_ELx_EXCEPTION {
        my($esr) = @_;
	    eval q(((($esr) &  &ESR_ELx_EC_MASK) >>  &ESR_ELx_EC_SHIFT));
    }' unless defined(&ESR_ELx_EXCEPTION);
    eval 'sub EXCP_UNKNOWN () {0x;}' unless defined(&EXCP_UNKNOWN);
    eval 'sub EXCP_FP_SIMD () {0x7;}' unless defined(&EXCP_FP_SIMD);
    eval 'sub EXCP_ILL_STATE () {0xe;}' unless defined(&EXCP_ILL_STATE);
    eval 'sub EXCP_SVC () {0x15;}' unless defined(&EXCP_SVC);
    eval 'sub EXCP_MSR () {0x18;}' unless defined(&EXCP_MSR);
    eval 'sub EXCP_INSN_ABORT_L () {0x20;}' unless defined(&EXCP_INSN_ABORT_L);
    eval 'sub EXCP_INSN_ABORT () {0x21;}' unless defined(&EXCP_INSN_ABORT);
    eval 'sub EXCP_PC_ALIGN () {0x22;}' unless defined(&EXCP_PC_ALIGN);
    eval 'sub EXCP_DATA_ABORT_L () {0x24;}' unless defined(&EXCP_DATA_ABORT_L);
    eval 'sub EXCP_DATA_ABORT () {0x25;}' unless defined(&EXCP_DATA_ABORT);
    eval 'sub EXCP_SP_ALIGN () {0x26;}' unless defined(&EXCP_SP_ALIGN);
    eval 'sub EXCP_TRAP_FP () {0x2c;}' unless defined(&EXCP_TRAP_FP);
    eval 'sub EXCP_SERROR () {0x2f;}' unless defined(&EXCP_SERROR);
    eval 'sub EXCP_SOFTSTP_EL0 () {0x32;}' unless defined(&EXCP_SOFTSTP_EL0);
    eval 'sub EXCP_SOFTSTP_EL1 () {0x33;}' unless defined(&EXCP_SOFTSTP_EL1);
    eval 'sub EXCP_WATCHPT_EL1 () {0x35;}' unless defined(&EXCP_WATCHPT_EL1);
    eval 'sub EXCP_BRK () {0x3c;}' unless defined(&EXCP_BRK);
    eval 'sub ICC_CTLR_EL1_EOIMODE () {(1 << 1);}' unless defined(&ICC_CTLR_EL1_EOIMODE);
    eval 'sub ICC_IAR1_EL1_SPUR () {(0x3ff);}' unless defined(&ICC_IAR1_EL1_SPUR);
    eval 'sub ICC_IGRPEN0_EL1_EN () {(1 << 0);}' unless defined(&ICC_IGRPEN0_EL1_EN);
    eval 'sub ICC_PMR_EL1_PRIO_MASK () {(0xff);}' unless defined(&ICC_PMR_EL1_PRIO_MASK);
    eval 'sub ICC_SGI1R_EL1_TL_MASK () {0xffff;}' unless defined(&ICC_SGI1R_EL1_TL_MASK);
    eval 'sub ICC_SGI1R_EL1_AFF1_SHIFT () {16;}' unless defined(&ICC_SGI1R_EL1_AFF1_SHIFT);
    eval 'sub ICC_SGI1R_EL1_SGIID_SHIFT () {24;}' unless defined(&ICC_SGI1R_EL1_SGIID_SHIFT);
    eval 'sub ICC_SGI1R_EL1_AFF2_SHIFT () {32;}' unless defined(&ICC_SGI1R_EL1_AFF2_SHIFT);
    eval 'sub ICC_SGI1R_EL1_AFF3_SHIFT () {48;}' unless defined(&ICC_SGI1R_EL1_AFF3_SHIFT);
    eval 'sub ICC_SGI1R_EL1_SGIID_MASK () {0xf;}' unless defined(&ICC_SGI1R_EL1_SGIID_MASK);
    eval 'sub ICC_SGI1R_EL1_IRM () {(0x1 << 40);}' unless defined(&ICC_SGI1R_EL1_IRM);
    eval 'sub ICC_SRE_EL1_SRE () {(1 << 0);}' unless defined(&ICC_SRE_EL1_SRE);
    eval 'sub ICC_SRE_EL2_SRE () {(1 << 0);}' unless defined(&ICC_SRE_EL2_SRE);
    eval 'sub ICC_SRE_EL2_EN () {(1 << 3);}' unless defined(&ICC_SRE_EL2_EN);
    eval 'sub ID_AA64DFR0_MASK () {0xf0f0ffff;}' unless defined(&ID_AA64DFR0_MASK);
    eval 'sub ID_AA64DFR0_DEBUG_VER_SHIFT () {0;}' unless defined(&ID_AA64DFR0_DEBUG_VER_SHIFT);
    eval 'sub ID_AA64DFR0_DEBUG_VER_MASK () {(0xf <<  &ID_AA64DFR0_DEBUG_VER_SHIFT);}' unless defined(&ID_AA64DFR0_DEBUG_VER_MASK);
    eval 'sub ID_AA64DFR0_DEBUG_VER {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64DFR0_DEBUG_VER_MASK));
    }' unless defined(&ID_AA64DFR0_DEBUG_VER);
    eval 'sub ID_AA64DFR0_DEBUG_VER_8 () {(0x6 <<  &ID_AA64DFR0_DEBUG_VER_SHIFT);}' unless defined(&ID_AA64DFR0_DEBUG_VER_8);
    eval 'sub ID_AA64DFR0_DEBUG_VER_8_VHE () {(0x7 <<  &ID_AA64DFR0_DEBUG_VER_SHIFT);}' unless defined(&ID_AA64DFR0_DEBUG_VER_8_VHE);
    eval 'sub ID_AA64DFR0_TRACE_VER_SHIFT () {4;}' unless defined(&ID_AA64DFR0_TRACE_VER_SHIFT);
    eval 'sub ID_AA64DFR0_TRACE_VER_MASK () {(0xf <<  &ID_AA64DFR0_TRACE_VER_SHIFT);}' unless defined(&ID_AA64DFR0_TRACE_VER_MASK);
    eval 'sub ID_AA64DFR0_TRACE_VER {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64DFR0_TRACE_VER_MASK));
    }' unless defined(&ID_AA64DFR0_TRACE_VER);
    eval 'sub ID_AA64DFR0_TRACE_VER_NONE () {(0x <<  &ID_AA64DFR0_TRACE_VER_SHIFT);}' unless defined(&ID_AA64DFR0_TRACE_VER_NONE);
    eval 'sub ID_AA64DFR0_TRACE_VER_IMPL () {(0x1 <<  &ID_AA64DFR0_TRACE_VER_SHIFT);}' unless defined(&ID_AA64DFR0_TRACE_VER_IMPL);
    eval 'sub ID_AA64DFR0_PMU_VER_SHIFT () {8;}' unless defined(&ID_AA64DFR0_PMU_VER_SHIFT);
    eval 'sub ID_AA64DFR0_PMU_VER_MASK () {(0xf <<  &ID_AA64DFR0_PMU_VER_SHIFT);}' unless defined(&ID_AA64DFR0_PMU_VER_MASK);
    eval 'sub ID_AA64DFR0_PMU_VER {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64DFR0_PMU_VER_MASK));
    }' unless defined(&ID_AA64DFR0_PMU_VER);
    eval 'sub ID_AA64DFR0_PMU_VER_NONE () {(0x <<  &ID_AA64DFR0_PMU_VER_SHIFT);}' unless defined(&ID_AA64DFR0_PMU_VER_NONE);
    eval 'sub ID_AA64DFR0_PMU_VER_3 () {(0x1 <<  &ID_AA64DFR0_PMU_VER_SHIFT);}' unless defined(&ID_AA64DFR0_PMU_VER_3);
    eval 'sub ID_AA64DFR0_PMU_VER_3_1 () {(0x4 <<  &ID_AA64DFR0_PMU_VER_SHIFT);}' unless defined(&ID_AA64DFR0_PMU_VER_3_1);
    eval 'sub ID_AA64DFR0_PMU_VER_IMPL () {(0xf <<  &ID_AA64DFR0_PMU_VER_SHIFT);}' unless defined(&ID_AA64DFR0_PMU_VER_IMPL);
    eval 'sub ID_AA64DFR0_BRPS_SHIFT () {12;}' unless defined(&ID_AA64DFR0_BRPS_SHIFT);
    eval 'sub ID_AA64DFR0_BRPS_MASK () {(0xf <<  &ID_AA64DFR0_BRPS_SHIFT);}' unless defined(&ID_AA64DFR0_BRPS_MASK);
    eval 'sub ID_AA64DFR0_BRPS {
        my($x) = @_;
	    eval q((((($x) >>  &ID_AA64DFR0_BRPS_SHIFT) & 0xf) + 1));
    }' unless defined(&ID_AA64DFR0_BRPS);
    eval 'sub ID_AA64DFR0_WRPS_SHIFT () {20;}' unless defined(&ID_AA64DFR0_WRPS_SHIFT);
    eval 'sub ID_AA64DFR0_WRPS_MASK () {(0xf <<  &ID_AA64DFR0_WRPS_SHIFT);}' unless defined(&ID_AA64DFR0_WRPS_MASK);
    eval 'sub ID_AA64DFR0_WRPS {
        my($x) = @_;
	    eval q((((($x) >>  &ID_AA64DFR0_WRPS_SHIFT) & 0xf) + 1));
    }' unless defined(&ID_AA64DFR0_WRPS);
    eval 'sub ID_AA64DFR0_CTX_CMPS_SHIFT () {28;}' unless defined(&ID_AA64DFR0_CTX_CMPS_SHIFT);
    eval 'sub ID_AA64DFR0_CTX_CMPS_MASK () {(0xf <<  &ID_AA64DFR0_CTX_CMPS_SHIFT);}' unless defined(&ID_AA64DFR0_CTX_CMPS_MASK);
    eval 'sub ID_AA64DFR0_CTX_CMPS {
        my($x) = @_;
	    eval q((((($x) >>  &ID_AA64DFR0_CTX_CMPS_SHIFT) & 0xf) + 1));
    }' unless defined(&ID_AA64DFR0_CTX_CMPS);
    eval 'sub ID_AA64ISAR0_MASK () {0xf0fffff0;}' unless defined(&ID_AA64ISAR0_MASK);
    eval 'sub ID_AA64ISAR0_AES_SHIFT () {4;}' unless defined(&ID_AA64ISAR0_AES_SHIFT);
    eval 'sub ID_AA64ISAR0_AES_MASK () {(0xf <<  &ID_AA64ISAR0_AES_SHIFT);}' unless defined(&ID_AA64ISAR0_AES_MASK);
    eval 'sub ID_AA64ISAR0_AES {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR0_AES_MASK));
    }' unless defined(&ID_AA64ISAR0_AES);
    eval 'sub ID_AA64ISAR0_AES_NONE () {(0x <<  &ID_AA64ISAR0_AES_SHIFT);}' unless defined(&ID_AA64ISAR0_AES_NONE);
    eval 'sub ID_AA64ISAR0_AES_BASE () {(0x1 <<  &ID_AA64ISAR0_AES_SHIFT);}' unless defined(&ID_AA64ISAR0_AES_BASE);
    eval 'sub ID_AA64ISAR0_AES_PMULL () {(0x2 <<  &ID_AA64ISAR0_AES_SHIFT);}' unless defined(&ID_AA64ISAR0_AES_PMULL);
    eval 'sub ID_AA64ISAR0_SHA1_SHIFT () {8;}' unless defined(&ID_AA64ISAR0_SHA1_SHIFT);
    eval 'sub ID_AA64ISAR0_SHA1_MASK () {(0xf <<  &ID_AA64ISAR0_SHA1_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA1_MASK);
    eval 'sub ID_AA64ISAR0_SHA1 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR0_SHA1_MASK));
    }' unless defined(&ID_AA64ISAR0_SHA1);
    eval 'sub ID_AA64ISAR0_SHA1_NONE () {(0x <<  &ID_AA64ISAR0_SHA1_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA1_NONE);
    eval 'sub ID_AA64ISAR0_SHA1_BASE () {(0x1 <<  &ID_AA64ISAR0_SHA1_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA1_BASE);
    eval 'sub ID_AA64ISAR0_SHA2_SHIFT () {12;}' unless defined(&ID_AA64ISAR0_SHA2_SHIFT);
    eval 'sub ID_AA64ISAR0_SHA2_MASK () {(0xf <<  &ID_AA64ISAR0_SHA2_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA2_MASK);
    eval 'sub ID_AA64ISAR0_SHA2 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR0_SHA2_MASK));
    }' unless defined(&ID_AA64ISAR0_SHA2);
    eval 'sub ID_AA64ISAR0_SHA2_NONE () {(0x <<  &ID_AA64ISAR0_SHA2_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA2_NONE);
    eval 'sub ID_AA64ISAR0_SHA2_BASE () {(0x1 <<  &ID_AA64ISAR0_SHA2_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA2_BASE);
    eval 'sub ID_AA64ISAR0_CRC32_SHIFT () {16;}' unless defined(&ID_AA64ISAR0_CRC32_SHIFT);
    eval 'sub ID_AA64ISAR0_CRC32_MASK () {(0xf <<  &ID_AA64ISAR0_CRC32_SHIFT);}' unless defined(&ID_AA64ISAR0_CRC32_MASK);
    eval 'sub ID_AA64ISAR0_CRC32 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR0_CRC32_MASK));
    }' unless defined(&ID_AA64ISAR0_CRC32);
    eval 'sub ID_AA64ISAR0_CRC32_NONE () {(0x <<  &ID_AA64ISAR0_CRC32_SHIFT);}' unless defined(&ID_AA64ISAR0_CRC32_NONE);
    eval 'sub ID_AA64ISAR0_CRC32_BASE () {(0x1 <<  &ID_AA64ISAR0_CRC32_SHIFT);}' unless defined(&ID_AA64ISAR0_CRC32_BASE);
    eval 'sub ID_AA64ISAR0_ATOMIC_SHIFT () {20;}' unless defined(&ID_AA64ISAR0_ATOMIC_SHIFT);
    eval 'sub ID_AA64ISAR0_ATOMIC_MASK () {(0xf <<  &ID_AA64ISAR0_ATOMIC_SHIFT);}' unless defined(&ID_AA64ISAR0_ATOMIC_MASK);
    eval 'sub ID_AA64ISAR0_ATOMIC {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR0_ATOMIC_MASK));
    }' unless defined(&ID_AA64ISAR0_ATOMIC);
    eval 'sub ID_AA64ISAR0_ATOMIC_NONE () {(0x <<  &ID_AA64ISAR0_ATOMIC_SHIFT);}' unless defined(&ID_AA64ISAR0_ATOMIC_NONE);
    eval 'sub ID_AA64ISAR0_ATOMIC_IMPL () {(0x2 <<  &ID_AA64ISAR0_ATOMIC_SHIFT);}' unless defined(&ID_AA64ISAR0_ATOMIC_IMPL);
    eval 'sub ID_AA64ISAR0_RDM_SHIFT () {28;}' unless defined(&ID_AA64ISAR0_RDM_SHIFT);
    eval 'sub ID_AA64ISAR0_RDM_MASK () {(0xf <<  &ID_AA64ISAR0_RDM_SHIFT);}' unless defined(&ID_AA64ISAR0_RDM_MASK);
    eval 'sub ID_AA64ISAR0_RDM {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR0_RDM_MASK));
    }' unless defined(&ID_AA64ISAR0_RDM);
    eval 'sub ID_AA64ISAR0_RDM_NONE () {(0x <<  &ID_AA64ISAR0_RDM_SHIFT);}' unless defined(&ID_AA64ISAR0_RDM_NONE);
    eval 'sub ID_AA64ISAR0_RDM_IMPL () {(0x1 <<  &ID_AA64ISAR0_RDM_SHIFT);}' unless defined(&ID_AA64ISAR0_RDM_IMPL);
    eval 'sub ID_AA64MMFR0_MASK () {0xffffffff;}' unless defined(&ID_AA64MMFR0_MASK);
    eval 'sub ID_AA64MMFR0_PA_RANGE_SHIFT () {0;}' unless defined(&ID_AA64MMFR0_PA_RANGE_SHIFT);
    eval 'sub ID_AA64MMFR0_PA_RANGE_MASK () {(0xf <<  &ID_AA64MMFR0_PA_RANGE_SHIFT);}' unless defined(&ID_AA64MMFR0_PA_RANGE_MASK);
    eval 'sub ID_AA64MMFR0_PA_RANGE {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR0_PA_RANGE_MASK));
    }' unless defined(&ID_AA64MMFR0_PA_RANGE);
    eval 'sub ID_AA64MMFR0_PA_RANGE_4G () {(0x <<  &ID_AA64MMFR0_PA_RANGE_SHIFT);}' unless defined(&ID_AA64MMFR0_PA_RANGE_4G);
    eval 'sub ID_AA64MMFR0_PA_RANGE_64G () {(0x1 <<  &ID_AA64MMFR0_PA_RANGE_SHIFT);}' unless defined(&ID_AA64MMFR0_PA_RANGE_64G);
    eval 'sub ID_AA64MMFR0_PA_RANGE_1T () {(0x2 <<  &ID_AA64MMFR0_PA_RANGE_SHIFT);}' unless defined(&ID_AA64MMFR0_PA_RANGE_1T);
    eval 'sub ID_AA64MMFR0_PA_RANGE_4T () {(0x3 <<  &ID_AA64MMFR0_PA_RANGE_SHIFT);}' unless defined(&ID_AA64MMFR0_PA_RANGE_4T);
    eval 'sub ID_AA64MMFR0_PA_RANGE_16T () {(0x4 <<  &ID_AA64MMFR0_PA_RANGE_SHIFT);}' unless defined(&ID_AA64MMFR0_PA_RANGE_16T);
    eval 'sub ID_AA64MMFR0_PA_RANGE_256T () {(0x5 <<  &ID_AA64MMFR0_PA_RANGE_SHIFT);}' unless defined(&ID_AA64MMFR0_PA_RANGE_256T);
    eval 'sub ID_AA64MMFR0_ASID_BITS_SHIFT () {4;}' unless defined(&ID_AA64MMFR0_ASID_BITS_SHIFT);
    eval 'sub ID_AA64MMFR0_ASID_BITS_MASK () {(0xf <<  &ID_AA64MMFR0_ASID_BITS_SHIFT);}' unless defined(&ID_AA64MMFR0_ASID_BITS_MASK);
    eval 'sub ID_AA64MMFR0_ASID_BITS {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR0_ASID_BITS_MASK));
    }' unless defined(&ID_AA64MMFR0_ASID_BITS);
    eval 'sub ID_AA64MMFR0_ASID_BITS_8 () {(0x <<  &ID_AA64MMFR0_ASID_BITS_SHIFT);}' unless defined(&ID_AA64MMFR0_ASID_BITS_8);
    eval 'sub ID_AA64MMFR0_ASID_BITS_16 () {(0x2 <<  &ID_AA64MMFR0_ASID_BITS_SHIFT);}' unless defined(&ID_AA64MMFR0_ASID_BITS_16);
    eval 'sub ID_AA64MMFR0_BIGEND_SHIFT () {8;}' unless defined(&ID_AA64MMFR0_BIGEND_SHIFT);
    eval 'sub ID_AA64MMFR0_BIGEND_MASK () {(0xf <<  &ID_AA64MMFR0_BIGEND_SHIFT);}' unless defined(&ID_AA64MMFR0_BIGEND_MASK);
    eval 'sub ID_AA64MMFR0_BIGEND {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR0_BIGEND_MASK));
    }' unless defined(&ID_AA64MMFR0_BIGEND);
    eval 'sub ID_AA64MMFR0_BIGEND_FIXED () {(0x <<  &ID_AA64MMFR0_BIGEND_SHIFT);}' unless defined(&ID_AA64MMFR0_BIGEND_FIXED);
    eval 'sub ID_AA64MMFR0_BIGEND_MIXED () {(0x1 <<  &ID_AA64MMFR0_BIGEND_SHIFT);}' unless defined(&ID_AA64MMFR0_BIGEND_MIXED);
    eval 'sub ID_AA64MMFR0_S_NS_MEM_SHIFT () {12;}' unless defined(&ID_AA64MMFR0_S_NS_MEM_SHIFT);
    eval 'sub ID_AA64MMFR0_S_NS_MEM_MASK () {(0xf <<  &ID_AA64MMFR0_S_NS_MEM_SHIFT);}' unless defined(&ID_AA64MMFR0_S_NS_MEM_MASK);
    eval 'sub ID_AA64MMFR0_S_NS_MEM {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR0_S_NS_MEM_MASK));
    }' unless defined(&ID_AA64MMFR0_S_NS_MEM);
    eval 'sub ID_AA64MMFR0_S_NS_MEM_NONE () {(0x <<  &ID_AA64MMFR0_S_NS_MEM_SHIFT);}' unless defined(&ID_AA64MMFR0_S_NS_MEM_NONE);
    eval 'sub ID_AA64MMFR0_S_NS_MEM_DISTINCT () {(0x1 <<  &ID_AA64MMFR0_S_NS_MEM_SHIFT);}' unless defined(&ID_AA64MMFR0_S_NS_MEM_DISTINCT);
    eval 'sub ID_AA64MMFR0_BIGEND_EL0_SHIFT () {16;}' unless defined(&ID_AA64MMFR0_BIGEND_EL0_SHIFT);
    eval 'sub ID_AA64MMFR0_BIGEND_EL0_MASK () {(0xf <<  &ID_AA64MMFR0_BIGEND_EL0_SHIFT);}' unless defined(&ID_AA64MMFR0_BIGEND_EL0_MASK);
    eval 'sub ID_AA64MMFR0_BIGEND_EL0 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR0_BIGEND_EL0_MASK));
    }' unless defined(&ID_AA64MMFR0_BIGEND_EL0);
    eval 'sub ID_AA64MMFR0_BIGEND_EL0_FIXED () {(0x <<  &ID_AA64MMFR0_BIGEND_EL0_SHIFT);}' unless defined(&ID_AA64MMFR0_BIGEND_EL0_FIXED);
    eval 'sub ID_AA64MMFR0_BIGEND_EL0_MIXED () {(0x1 <<  &ID_AA64MMFR0_BIGEND_EL0_SHIFT);}' unless defined(&ID_AA64MMFR0_BIGEND_EL0_MIXED);
    eval 'sub ID_AA64MMFR0_TGRAN16_SHIFT () {20;}' unless defined(&ID_AA64MMFR0_TGRAN16_SHIFT);
    eval 'sub ID_AA64MMFR0_TGRAN16_MASK () {(0xf <<  &ID_AA64MMFR0_TGRAN16_SHIFT);}' unless defined(&ID_AA64MMFR0_TGRAN16_MASK);
    eval 'sub ID_AA64MMFR0_TGRAN16 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR0_TGRAN16_MASK));
    }' unless defined(&ID_AA64MMFR0_TGRAN16);
    eval 'sub ID_AA64MMFR0_TGRAN16_NONE () {(0x <<  &ID_AA64MMFR0_TGRAN16_SHIFT);}' unless defined(&ID_AA64MMFR0_TGRAN16_NONE);
    eval 'sub ID_AA64MMFR0_TGRAN16_IMPL () {(0x1 <<  &ID_AA64MMFR0_TGRAN16_SHIFT);}' unless defined(&ID_AA64MMFR0_TGRAN16_IMPL);
    eval 'sub ID_AA64MMFR0_TGRAN64_SHIFT () {24;}' unless defined(&ID_AA64MMFR0_TGRAN64_SHIFT);
    eval 'sub ID_AA64MMFR0_TGRAN64_MASK () {(0xf <<  &ID_AA64MMFR0_TGRAN64_SHIFT);}' unless defined(&ID_AA64MMFR0_TGRAN64_MASK);
    eval 'sub ID_AA64MMFR0_TGRAN64 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR0_TGRAN64_MASK));
    }' unless defined(&ID_AA64MMFR0_TGRAN64);
    eval 'sub ID_AA64MMFR0_TGRAN64_IMPL () {(0x <<  &ID_AA64MMFR0_TGRAN64_SHIFT);}' unless defined(&ID_AA64MMFR0_TGRAN64_IMPL);
    eval 'sub ID_AA64MMFR0_TGRAN64_NONE () {(0xf <<  &ID_AA64MMFR0_TGRAN64_SHIFT);}' unless defined(&ID_AA64MMFR0_TGRAN64_NONE);
    eval 'sub ID_AA64MMFR0_TGRAN4_SHIFT () {28;}' unless defined(&ID_AA64MMFR0_TGRAN4_SHIFT);
    eval 'sub ID_AA64MMFR0_TGRAN4_MASK () {(0xf <<  &ID_AA64MMFR0_TGRAN4_SHIFT);}' unless defined(&ID_AA64MMFR0_TGRAN4_MASK);
    eval 'sub ID_AA64MMFR0_TGRAN4 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR0_TGRAN4_MASK));
    }' unless defined(&ID_AA64MMFR0_TGRAN4);
    eval 'sub ID_AA64MMFR0_TGRAN4_IMPL () {(0x <<  &ID_AA64MMFR0_TGRAN4_SHIFT);}' unless defined(&ID_AA64MMFR0_TGRAN4_IMPL);
    eval 'sub ID_AA64MMFR0_TGRAN4_NONE () {(0xf <<  &ID_AA64MMFR0_TGRAN4_SHIFT);}' unless defined(&ID_AA64MMFR0_TGRAN4_NONE);
    eval 'sub ID_AA64MMFR1_MASK () {0xffffff;}' unless defined(&ID_AA64MMFR1_MASK);
    eval 'sub ID_AA64MMFR1_HAFDBS_SHIFT () {0;}' unless defined(&ID_AA64MMFR1_HAFDBS_SHIFT);
    eval 'sub ID_AA64MMFR1_HAFDBS_MASK () {(0xf <<  &ID_AA64MMFR1_HAFDBS_SHIFT);}' unless defined(&ID_AA64MMFR1_HAFDBS_MASK);
    eval 'sub ID_AA64MMFR1_HAFDBS {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR1_HAFDBS_MASK));
    }' unless defined(&ID_AA64MMFR1_HAFDBS);
    eval 'sub ID_AA64MMFR1_HAFDBS_NONE () {(0x <<  &ID_AA64MMFR1_HAFDBS_SHIFT);}' unless defined(&ID_AA64MMFR1_HAFDBS_NONE);
    eval 'sub ID_AA64MMFR1_HAFDBS_AF () {(0x1 <<  &ID_AA64MMFR1_HAFDBS_SHIFT);}' unless defined(&ID_AA64MMFR1_HAFDBS_AF);
    eval 'sub ID_AA64MMFR1_HAFDBS_AF_DBS () {(0x2 <<  &ID_AA64MMFR1_HAFDBS_SHIFT);}' unless defined(&ID_AA64MMFR1_HAFDBS_AF_DBS);
    eval 'sub ID_AA64MMFR1_VMIDBITS_SHIFT () {4;}' unless defined(&ID_AA64MMFR1_VMIDBITS_SHIFT);
    eval 'sub ID_AA64MMFR1_VMIDBITS_MASK () {(0xf <<  &ID_AA64MMFR1_VMIDBITS_SHIFT);}' unless defined(&ID_AA64MMFR1_VMIDBITS_MASK);
    eval 'sub ID_AA64MMFR1_VMIDBITS {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR1_VMIDBITS_MASK));
    }' unless defined(&ID_AA64MMFR1_VMIDBITS);
    eval 'sub ID_AA64MMFR1_VMIDBITS_8 () {(0x <<  &ID_AA64MMFR1_VMIDBITS_SHIFT);}' unless defined(&ID_AA64MMFR1_VMIDBITS_8);
    eval 'sub ID_AA64MMFR1_VMIDBITS_16 () {(0x2 <<  &ID_AA64MMFR1_VMIDBITS_SHIFT);}' unless defined(&ID_AA64MMFR1_VMIDBITS_16);
    eval 'sub ID_AA64MMFR1_VH_SHIFT () {8;}' unless defined(&ID_AA64MMFR1_VH_SHIFT);
    eval 'sub ID_AA64MMFR1_VH_MASK () {(0xf <<  &ID_AA64MMFR1_VH_SHIFT);}' unless defined(&ID_AA64MMFR1_VH_MASK);
    eval 'sub ID_AA64MMFR1_VH {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR1_VH_MASK));
    }' unless defined(&ID_AA64MMFR1_VH);
    eval 'sub ID_AA64MMFR1_VH_NONE () {(0x <<  &ID_AA64MMFR1_VH_SHIFT);}' unless defined(&ID_AA64MMFR1_VH_NONE);
    eval 'sub ID_AA64MMFR1_VH_IMPL () {(0x1 <<  &ID_AA64MMFR1_VH_SHIFT);}' unless defined(&ID_AA64MMFR1_VH_IMPL);
    eval 'sub ID_AA64MMFR1_HPDS_SHIFT () {12;}' unless defined(&ID_AA64MMFR1_HPDS_SHIFT);
    eval 'sub ID_AA64MMFR1_HPDS_MASK () {(0xf <<  &ID_AA64MMFR1_HPDS_SHIFT);}' unless defined(&ID_AA64MMFR1_HPDS_MASK);
    eval 'sub ID_AA64MMFR1_HPDS {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR1_HPDS_MASK));
    }' unless defined(&ID_AA64MMFR1_HPDS);
    eval 'sub ID_AA64MMFR1_HPDS_NONE () {(0x <<  &ID_AA64MMFR1_HPDS_SHIFT);}' unless defined(&ID_AA64MMFR1_HPDS_NONE);
    eval 'sub ID_AA64MMFR1_HPDS_IMPL () {(0x1 <<  &ID_AA64MMFR1_HPDS_SHIFT);}' unless defined(&ID_AA64MMFR1_HPDS_IMPL);
    eval 'sub ID_AA64MMFR1_LO_SHIFT () {16;}' unless defined(&ID_AA64MMFR1_LO_SHIFT);
    eval 'sub ID_AA64MMFR1_LO_MASK () {(0xf <<  &ID_AA64MMFR1_LO_SHIFT);}' unless defined(&ID_AA64MMFR1_LO_MASK);
    eval 'sub ID_AA64MMFR1_LO {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR1_LO_MASK));
    }' unless defined(&ID_AA64MMFR1_LO);
    eval 'sub ID_AA64MMFR1_LO_NONE () {(0x <<  &ID_AA64MMFR1_LO_SHIFT);}' unless defined(&ID_AA64MMFR1_LO_NONE);
    eval 'sub ID_AA64MMFR1_LO_IMPL () {(0x1 <<  &ID_AA64MMFR1_LO_SHIFT);}' unless defined(&ID_AA64MMFR1_LO_IMPL);
    eval 'sub ID_AA64MMFR1_PAN_SHIFT () {20;}' unless defined(&ID_AA64MMFR1_PAN_SHIFT);
    eval 'sub ID_AA64MMFR1_PAN_MASK () {(0xf <<  &ID_AA64MMFR1_PAN_SHIFT);}' unless defined(&ID_AA64MMFR1_PAN_MASK);
    eval 'sub ID_AA64MMFR1_PAN {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR1_PAN_MASK));
    }' unless defined(&ID_AA64MMFR1_PAN);
    eval 'sub ID_AA64MMFR1_PAN_NONE () {(0x <<  &ID_AA64MMFR1_PAN_SHIFT);}' unless defined(&ID_AA64MMFR1_PAN_NONE);
    eval 'sub ID_AA64MMFR1_PAN_IMPL () {(0x1 <<  &ID_AA64MMFR1_PAN_SHIFT);}' unless defined(&ID_AA64MMFR1_PAN_IMPL);
    eval 'sub ID_AA64MMFR1_PAN_ATS1E1 () {(0x2 <<  &ID_AA64MMFR1_PAN_SHIFT);}' unless defined(&ID_AA64MMFR1_PAN_ATS1E1);
    eval 'sub ID_AA64PFR0_MASK () {0xfffffff;}' unless defined(&ID_AA64PFR0_MASK);
    eval 'sub ID_AA64PFR0_EL0_SHIFT () {0;}' unless defined(&ID_AA64PFR0_EL0_SHIFT);
    eval 'sub ID_AA64PFR0_EL0_MASK () {(0xf <<  &ID_AA64PFR0_EL0_SHIFT);}' unless defined(&ID_AA64PFR0_EL0_MASK);
    eval 'sub ID_AA64PFR0_EL0 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64PFR0_EL0_MASK));
    }' unless defined(&ID_AA64PFR0_EL0);
    eval 'sub ID_AA64PFR0_EL0_64 () {(1<<  &ID_AA64PFR0_EL0_SHIFT);}' unless defined(&ID_AA64PFR0_EL0_64);
    eval 'sub ID_AA64PFR0_EL0_64_32 () {(2<<  &ID_AA64PFR0_EL0_SHIFT);}' unless defined(&ID_AA64PFR0_EL0_64_32);
    eval 'sub ID_AA64PFR0_EL1_SHIFT () {4;}' unless defined(&ID_AA64PFR0_EL1_SHIFT);
    eval 'sub ID_AA64PFR0_EL1_MASK () {(0xf <<  &ID_AA64PFR0_EL1_SHIFT);}' unless defined(&ID_AA64PFR0_EL1_MASK);
    eval 'sub ID_AA64PFR0_EL1 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64PFR0_EL1_MASK));
    }' unless defined(&ID_AA64PFR0_EL1);
    eval 'sub ID_AA64PFR0_EL1_64 () {(1<<  &ID_AA64PFR0_EL1_SHIFT);}' unless defined(&ID_AA64PFR0_EL1_64);
    eval 'sub ID_AA64PFR0_EL1_64_32 () {(2<<  &ID_AA64PFR0_EL1_SHIFT);}' unless defined(&ID_AA64PFR0_EL1_64_32);
    eval 'sub ID_AA64PFR0_EL2_SHIFT () {8;}' unless defined(&ID_AA64PFR0_EL2_SHIFT);
    eval 'sub ID_AA64PFR0_EL2_MASK () {(0xf <<  &ID_AA64PFR0_EL2_SHIFT);}' unless defined(&ID_AA64PFR0_EL2_MASK);
    eval 'sub ID_AA64PFR0_EL2 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64PFR0_EL2_MASK));
    }' unless defined(&ID_AA64PFR0_EL2);
    eval 'sub ID_AA64PFR0_EL2_NONE () {(0<<  &ID_AA64PFR0_EL2_SHIFT);}' unless defined(&ID_AA64PFR0_EL2_NONE);
    eval 'sub ID_AA64PFR0_EL2_64 () {(1<<  &ID_AA64PFR0_EL2_SHIFT);}' unless defined(&ID_AA64PFR0_EL2_64);
    eval 'sub ID_AA64PFR0_EL2_64_32 () {(2<<  &ID_AA64PFR0_EL2_SHIFT);}' unless defined(&ID_AA64PFR0_EL2_64_32);
    eval 'sub ID_AA64PFR0_EL3_SHIFT () {12;}' unless defined(&ID_AA64PFR0_EL3_SHIFT);
    eval 'sub ID_AA64PFR0_EL3_MASK () {(0xf <<  &ID_AA64PFR0_EL3_SHIFT);}' unless defined(&ID_AA64PFR0_EL3_MASK);
    eval 'sub ID_AA64PFR0_EL3 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64PFR0_EL3_MASK));
    }' unless defined(&ID_AA64PFR0_EL3);
    eval 'sub ID_AA64PFR0_EL3_NONE () {(0<<  &ID_AA64PFR0_EL3_SHIFT);}' unless defined(&ID_AA64PFR0_EL3_NONE);
    eval 'sub ID_AA64PFR0_EL3_64 () {(1<<  &ID_AA64PFR0_EL3_SHIFT);}' unless defined(&ID_AA64PFR0_EL3_64);
    eval 'sub ID_AA64PFR0_EL3_64_32 () {(2<<  &ID_AA64PFR0_EL3_SHIFT);}' unless defined(&ID_AA64PFR0_EL3_64_32);
    eval 'sub ID_AA64PFR0_FP_SHIFT () {16;}' unless defined(&ID_AA64PFR0_FP_SHIFT);
    eval 'sub ID_AA64PFR0_FP_MASK () {(0xf <<  &ID_AA64PFR0_FP_SHIFT);}' unless defined(&ID_AA64PFR0_FP_MASK);
    eval 'sub ID_AA64PFR0_FP {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64PFR0_FP_MASK));
    }' unless defined(&ID_AA64PFR0_FP);
    eval 'sub ID_AA64PFR0_FP_IMPL () {(0x <<  &ID_AA64PFR0_FP_SHIFT);}' unless defined(&ID_AA64PFR0_FP_IMPL);
    eval 'sub ID_AA64PFR0_FP_NONE () {(0xf <<  &ID_AA64PFR0_FP_SHIFT);}' unless defined(&ID_AA64PFR0_FP_NONE);
    eval 'sub ID_AA64PFR0_ADV_SIMD_SHIFT () {20;}' unless defined(&ID_AA64PFR0_ADV_SIMD_SHIFT);
    eval 'sub ID_AA64PFR0_ADV_SIMD_MASK () {(0xf <<  &ID_AA64PFR0_ADV_SIMD_SHIFT);}' unless defined(&ID_AA64PFR0_ADV_SIMD_MASK);
    eval 'sub ID_AA64PFR0_ADV_SIMD {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64PFR0_ADV_SIMD_MASK));
    }' unless defined(&ID_AA64PFR0_ADV_SIMD);
    eval 'sub ID_AA64PFR0_ADV_SIMD_IMPL () {(0x <<  &ID_AA64PFR0_ADV_SIMD_SHIFT);}' unless defined(&ID_AA64PFR0_ADV_SIMD_IMPL);
    eval 'sub ID_AA64PFR0_ADV_SIMD_NONE () {(0xf <<  &ID_AA64PFR0_ADV_SIMD_SHIFT);}' unless defined(&ID_AA64PFR0_ADV_SIMD_NONE);
    eval 'sub ID_AA64PFR0_GIC_BITS () {0x4;}' unless defined(&ID_AA64PFR0_GIC_BITS);
    eval 'sub ID_AA64PFR0_GIC_SHIFT () {24;}' unless defined(&ID_AA64PFR0_GIC_SHIFT);
    eval 'sub ID_AA64PFR0_GIC_MASK () {(0xf <<  &ID_AA64PFR0_GIC_SHIFT);}' unless defined(&ID_AA64PFR0_GIC_MASK);
    eval 'sub ID_AA64PFR0_GIC {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64PFR0_GIC_MASK));
    }' unless defined(&ID_AA64PFR0_GIC);
    eval 'sub ID_AA64PFR0_GIC_CPUIF_NONE () {(0x <<  &ID_AA64PFR0_GIC_SHIFT);}' unless defined(&ID_AA64PFR0_GIC_CPUIF_NONE);
    eval 'sub ID_AA64PFR0_GIC_CPUIF_EN () {(0x1 <<  &ID_AA64PFR0_GIC_SHIFT);}' unless defined(&ID_AA64PFR0_GIC_CPUIF_EN);
    eval 'sub MAIR_ATTR_MASK {
        my($idx) = @_;
	    eval q((0xff << (( &n)* 8)));
    }' unless defined(&MAIR_ATTR_MASK);
    eval 'sub MAIR_ATTR {
        my($attr, $idx) = @_;
	    eval q((($attr) << (($idx) * 8)));
    }' unless defined(&MAIR_ATTR);
    eval 'sub MAIR_DEVICE_nGnRnE () {0x;}' unless defined(&MAIR_DEVICE_nGnRnE);
    eval 'sub MAIR_NORMAL_NC () {0x44;}' unless defined(&MAIR_NORMAL_NC);
    eval 'sub MAIR_NORMAL_WT () {0x88;}' unless defined(&MAIR_NORMAL_WT);
    eval 'sub MAIR_NORMAL_WB () {0xff;}' unless defined(&MAIR_NORMAL_WB);
    eval 'sub PAR_F_SHIFT () {0;}' unless defined(&PAR_F_SHIFT);
    eval 'sub PAR_F () {(0x1 <<  &PAR_F_SHIFT);}' unless defined(&PAR_F);
    eval 'sub PAR_SUCCESS {
        my($x) = @_;
	    eval q(((($x) &  &PAR_F) == 0));
    }' unless defined(&PAR_SUCCESS);
    eval 'sub PAR_SH_SHIFT () {7;}' unless defined(&PAR_SH_SHIFT);
    eval 'sub PAR_SH_MASK () {(0x3 <<  &PAR_SH_SHIFT);}' unless defined(&PAR_SH_MASK);
    eval 'sub PAR_NS_SHIFT () {9;}' unless defined(&PAR_NS_SHIFT);
    eval 'sub PAR_NS_MASK () {(0x3 <<  &PAR_NS_SHIFT);}' unless defined(&PAR_NS_MASK);
    eval 'sub PAR_PA_SHIFT () {12;}' unless defined(&PAR_PA_SHIFT);
    eval 'sub PAR_PA_MASK () {0xfffffffff000;}' unless defined(&PAR_PA_MASK);
    eval 'sub PAR_ATTR_SHIFT () {56;}' unless defined(&PAR_ATTR_SHIFT);
    eval 'sub PAR_ATTR_MASK () {(0xff <<  &PAR_ATTR_SHIFT);}' unless defined(&PAR_ATTR_MASK);
    eval 'sub PAR_FST_SHIFT () {1;}' unless defined(&PAR_FST_SHIFT);
    eval 'sub PAR_FST_MASK () {(0x3f <<  &PAR_FST_SHIFT);}' unless defined(&PAR_FST_MASK);
    eval 'sub PAR_PTW_SHIFT () {8;}' unless defined(&PAR_PTW_SHIFT);
    eval 'sub PAR_PTW_MASK () {(0x1 <<  &PAR_PTW_SHIFT);}' unless defined(&PAR_PTW_MASK);
    eval 'sub PAR_S_SHIFT () {9;}' unless defined(&PAR_S_SHIFT);
    eval 'sub PAR_S_MASK () {(0x1 <<  &PAR_S_SHIFT);}' unless defined(&PAR_S_MASK);
    eval 'sub SCTLR_RES0 () {0xc8222400;}' unless defined(&SCTLR_RES0);
    eval 'sub SCTLR_RES1 () {0x30d00800;}' unless defined(&SCTLR_RES1);
    eval 'sub SCTLR_M () {0x1;}' unless defined(&SCTLR_M);
    eval 'sub SCTLR_A () {0x2;}' unless defined(&SCTLR_A);
    eval 'sub SCTLR_C () {0x4;}' unless defined(&SCTLR_C);
    eval 'sub SCTLR_SA () {0x8;}' unless defined(&SCTLR_SA);
    eval 'sub SCTLR_SA0 () {0x10;}' unless defined(&SCTLR_SA0);
    eval 'sub SCTLR_CP15BEN () {0x20;}' unless defined(&SCTLR_CP15BEN);
    eval 'sub SCTLR_THEE () {0x40;}' unless defined(&SCTLR_THEE);
    eval 'sub SCTLR_ITD () {0x80;}' unless defined(&SCTLR_ITD);
    eval 'sub SCTLR_SED () {0x100;}' unless defined(&SCTLR_SED);
    eval 'sub SCTLR_UMA () {0x200;}' unless defined(&SCTLR_UMA);
    eval 'sub SCTLR_I () {0x1000;}' unless defined(&SCTLR_I);
    eval 'sub SCTLR_DZE () {0x4000;}' unless defined(&SCTLR_DZE);
    eval 'sub SCTLR_UCT () {0x8000;}' unless defined(&SCTLR_UCT);
    eval 'sub SCTLR_nTWI () {0x10000;}' unless defined(&SCTLR_nTWI);
    eval 'sub SCTLR_nTWE () {0x40000;}' unless defined(&SCTLR_nTWE);
    eval 'sub SCTLR_WXN () {0x80000;}' unless defined(&SCTLR_WXN);
    eval 'sub SCTLR_IESB () {0x200000;}' unless defined(&SCTLR_IESB);
    eval 'sub SCTLR_SPAN () {0x800000;}' unless defined(&SCTLR_SPAN);
    eval 'sub SCTLR_EOE () {0x1000000;}' unless defined(&SCTLR_EOE);
    eval 'sub SCTLR_EE () {0x2000000;}' unless defined(&SCTLR_EE);
    eval 'sub SCTLR_UCI () {0x4000000;}' unless defined(&SCTLR_UCI);
    eval 'sub SCTLR_nTLSMD () {0x10000000;}' unless defined(&SCTLR_nTLSMD);
    eval 'sub SCTLR_LSMAOE () {0x20000000;}' unless defined(&SCTLR_LSMAOE);
    eval 'sub PSR_M_EL0t () {0x;}' unless defined(&PSR_M_EL0t);
    eval 'sub PSR_M_EL1t () {0x4;}' unless defined(&PSR_M_EL1t);
    eval 'sub PSR_M_EL1h () {0x5;}' unless defined(&PSR_M_EL1h);
    eval 'sub PSR_M_EL2t () {0x8;}' unless defined(&PSR_M_EL2t);
    eval 'sub PSR_M_EL2h () {0x9;}' unless defined(&PSR_M_EL2h);
    eval 'sub PSR_M_MASK () {0x1f;}' unless defined(&PSR_M_MASK);
    eval 'sub PSR_F () {0x40;}' unless defined(&PSR_F);
    eval 'sub PSR_I () {0x80;}' unless defined(&PSR_I);
    eval 'sub PSR_A () {0x100;}' unless defined(&PSR_A);
    eval 'sub PSR_D () {0x200;}' unless defined(&PSR_D);
    eval 'sub PSR_IL () {0x100000;}' unless defined(&PSR_IL);
    eval 'sub PSR_SS () {0x200000;}' unless defined(&PSR_SS);
    eval 'sub PSR_V () {0x10000000;}' unless defined(&PSR_V);
    eval 'sub PSR_C () {0x20000000;}' unless defined(&PSR_C);
    eval 'sub PSR_Z () {0x40000000;}' unless defined(&PSR_Z);
    eval 'sub PSR_N () {0x80000000;}' unless defined(&PSR_N);
    eval 'sub PSR_FLAGS () {0xf0000000;}' unless defined(&PSR_FLAGS);
    eval 'sub TCR_ASID_16 () {(1<< 36);}' unless defined(&TCR_ASID_16);
    eval 'sub TCR_IPS_SHIFT () {32;}' unless defined(&TCR_IPS_SHIFT);
    eval 'sub TCR_IPS_32BIT () {(0<<  &TCR_IPS_SHIFT);}' unless defined(&TCR_IPS_32BIT);
    eval 'sub TCR_IPS_36BIT () {(1<<  &TCR_IPS_SHIFT);}' unless defined(&TCR_IPS_36BIT);
    eval 'sub TCR_IPS_40BIT () {(2<<  &TCR_IPS_SHIFT);}' unless defined(&TCR_IPS_40BIT);
    eval 'sub TCR_IPS_42BIT () {(3<<  &TCR_IPS_SHIFT);}' unless defined(&TCR_IPS_42BIT);
    eval 'sub TCR_IPS_44BIT () {(4<<  &TCR_IPS_SHIFT);}' unless defined(&TCR_IPS_44BIT);
    eval 'sub TCR_IPS_48BIT () {(5<<  &TCR_IPS_SHIFT);}' unless defined(&TCR_IPS_48BIT);
    eval 'sub TCR_TG1_SHIFT () {30;}' unless defined(&TCR_TG1_SHIFT);
    eval 'sub TCR_TG1_16K () {(1<<  &TCR_TG1_SHIFT);}' unless defined(&TCR_TG1_16K);
    eval 'sub TCR_TG1_4K () {(2<<  &TCR_TG1_SHIFT);}' unless defined(&TCR_TG1_4K);
    eval 'sub TCR_TG1_64K () {(3<<  &TCR_TG1_SHIFT);}' unless defined(&TCR_TG1_64K);
    eval 'sub TCR_SH1_SHIFT () {28;}' unless defined(&TCR_SH1_SHIFT);
    eval 'sub TCR_SH1_IS () {(0x3 <<  &TCR_SH1_SHIFT);}' unless defined(&TCR_SH1_IS);
    eval 'sub TCR_ORGN1_SHIFT () {26;}' unless defined(&TCR_ORGN1_SHIFT);
    eval 'sub TCR_ORGN1_WBWA () {(0x1 <<  &TCR_ORGN1_SHIFT);}' unless defined(&TCR_ORGN1_WBWA);
    eval 'sub TCR_IRGN1_SHIFT () {24;}' unless defined(&TCR_IRGN1_SHIFT);
    eval 'sub TCR_IRGN1_WBWA () {(0x1 <<  &TCR_IRGN1_SHIFT);}' unless defined(&TCR_IRGN1_WBWA);
    eval 'sub TCR_SH0_SHIFT () {12;}' unless defined(&TCR_SH0_SHIFT);
    eval 'sub TCR_SH0_IS () {(0x3 <<  &TCR_SH0_SHIFT);}' unless defined(&TCR_SH0_IS);
    eval 'sub TCR_ORGN0_SHIFT () {10;}' unless defined(&TCR_ORGN0_SHIFT);
    eval 'sub TCR_ORGN0_WBWA () {(0x1 <<  &TCR_ORGN0_SHIFT);}' unless defined(&TCR_ORGN0_WBWA);
    eval 'sub TCR_IRGN0_SHIFT () {8;}' unless defined(&TCR_IRGN0_SHIFT);
    eval 'sub TCR_IRGN0_WBWA () {(0x1 <<  &TCR_IRGN0_SHIFT);}' unless defined(&TCR_IRGN0_WBWA);
    eval 'sub TCR_CACHE_ATTRS () {(( &TCR_IRGN0_WBWA |  &TCR_IRGN1_WBWA) | ( &TCR_ORGN0_WBWA |  &TCR_ORGN1_WBWA));}' unless defined(&TCR_CACHE_ATTRS);
    if(defined(&SMP)) {
	eval 'sub TCR_SMP_ATTRS () {( &TCR_SH0_IS |  &TCR_SH1_IS);}' unless defined(&TCR_SMP_ATTRS);
    } else {
	eval 'sub TCR_SMP_ATTRS () {0;}' unless defined(&TCR_SMP_ATTRS);
    }
    eval 'sub TCR_T1SZ_SHIFT () {16;}' unless defined(&TCR_T1SZ_SHIFT);
    eval 'sub TCR_T0SZ_SHIFT () {0;}' unless defined(&TCR_T0SZ_SHIFT);
    eval 'sub TCR_T1SZ {
        my($x) = @_;
	    eval q((($x) <<  &TCR_T1SZ_SHIFT));
    }' unless defined(&TCR_T1SZ);
    eval 'sub TCR_T0SZ {
        my($x) = @_;
	    eval q((($x) <<  &TCR_T0SZ_SHIFT));
    }' unless defined(&TCR_T0SZ);
    eval 'sub TCR_TxSZ {
        my($x) = @_;
	    eval q(( &TCR_T1SZ($x) |  &TCR_T0SZ($x)));
    }' unless defined(&TCR_TxSZ);
    eval 'sub DBG_SPSR_SS () {(0x1 << 21);}' unless defined(&DBG_SPSR_SS);
    eval 'sub DBG_MDSCR_SS () {(0x1 << 0);}' unless defined(&DBG_MDSCR_SS);
    eval 'sub DBG_MDSCR_KDE () {(0x1 << 13);}' unless defined(&DBG_MDSCR_KDE);
    eval 'sub DBG_MDSCR_MDE () {(0x1 << 15);}' unless defined(&DBG_MDSCR_MDE);
    eval 'sub PMCR_E () {(1<< 0);}' unless defined(&PMCR_E);
    eval 'sub PMCR_P () {(1<< 1);}' unless defined(&PMCR_P);
    eval 'sub PMCR_C () {(1<< 2);}' unless defined(&PMCR_C);
    eval 'sub PMCR_D () {(1<< 3);}' unless defined(&PMCR_D);
    eval 'sub PMCR_X () {(1<< 4);}' unless defined(&PMCR_X);
    eval 'sub PMCR_DP () {(1<< 5);}' unless defined(&PMCR_DP);
    eval 'sub PMCR_LC () {(1<< 6);}' unless defined(&PMCR_LC);
    eval 'sub PMCR_IMP_SHIFT () {24;}' unless defined(&PMCR_IMP_SHIFT);
    eval 'sub PMCR_IMP_MASK () {(0xff <<  &PMCR_IMP_SHIFT);}' unless defined(&PMCR_IMP_MASK);
    eval 'sub PMCR_IDCODE_SHIFT () {16;}' unless defined(&PMCR_IDCODE_SHIFT);
    eval 'sub PMCR_IDCODE_MASK () {(0xff <<  &PMCR_IDCODE_SHIFT);}' unless defined(&PMCR_IDCODE_MASK);
    eval 'sub PMCR_IDCODE_CORTEX_A57 () {0x1;}' unless defined(&PMCR_IDCODE_CORTEX_A57);
    eval 'sub PMCR_IDCODE_CORTEX_A72 () {0x2;}' unless defined(&PMCR_IDCODE_CORTEX_A72);
    eval 'sub PMCR_IDCODE_CORTEX_A53 () {0x3;}' unless defined(&PMCR_IDCODE_CORTEX_A53);
    eval 'sub PMCR_N_SHIFT () {11;}' unless defined(&PMCR_N_SHIFT);
    eval 'sub PMCR_N_MASK () {(0x1f <<  &PMCR_N_SHIFT);}' unless defined(&PMCR_N_MASK);
}
1;
